---
title: File System Access API
slug: Web/API/File_System_Access_API
tags:
  - API
  - Directory
  - File
  - File Access
  - File System Access
  - File System Access API
  - Landing
  - Overview
  - working with files
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The File System Access API allows read, write and file management capabilities.</p>

<h2 id="Concepts_and_Usage">Concepts and Usage</h2>

<p>The API allows interaction with files on a users local device. These don't have to be files directly stored on the device, they can be files accessed through cloud storage software. Core functionality includes reading files, writing or saving files, as well as access to directory structure.</p>

<p>It expands the current file capabilities of a browser and can enable developers to create software to open and save files. Software such as IDE's, photo or video editors and text editors, to name but a few.</p>

<p>Most of the interaction with files and directories is accomplished through handles. A parent {{domxref('FileSystemHandle')}} class helps define two child classes: {{domxref('FileSystemFileHandle')}} and {{domxref('FileSystemDirectoryHandle')}}, depending if you want to work with files or directories respectively.</p>

<p>These handles represent the file or directory on the users system. You gain access to them by showing the user a file or directory picker. The methods which allow this are {{domxref('window.showOpenFilePicker')}} and {{domxref('window.showDirectoryPicker')}}. Once these are called the picker presents itself and the user selects either a file or directory. Once this happens successfully a handle is returned. You can also gain access to file handles via the {{domxref('DataTransferItem.getAsFileSystemHandle()')}} method of the {{domxref('HTML Drag and Drop API')}}.</p>

<p>The handle provides it's own functionality and there are a few differences depending on whether a file or directory was selected (see the below <a href="#Interfaces">interfaces</a> section for specific details). For the main part you gain access to the file data, or information (including children) of the directory selected.</p>

<p>There is also save functionality, which is where the {{domxref('FilesystemWritableFileStream')}} interface comes in. Once the data you'd like to save is in a format of {{domxref('Blob')}}, {{domxref('USVString')}} or {{jsxref('ArrayBuffer', 'buffer')}}, you can open a stream and save the data to a file. That can be the existing file or a new file.</p>

<p>Primarily this API opens up functionality the web has been lacking. Security has been of upmost consideration when designing the API and access to file/directory data is not allowed unless the user specifically permits it.</p>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("FileSystemHandle")}}</dt>
 <dd>The <strong><code>FileSystemHandle</code></strong> interface is an object which represents an entry. Multiple handles can represent the same entry. For the most part you do not work with <code>FileSystemEntry</code> directly but rather it's child interfaces {{domxref('FileSystemFileEntry')}} and {{domxref('FileSystemDirectoryEntry')}}.</dd>
 <dt>{{domxref("FileSystemFileHandle")}}</dt>
 <dd>Provides a handle to a file system entry.</dd>
 <dt>{{domxref("FileSystemDirectoryHandle")}}</dt>
 <dd>provides a handle to a file system directory.</dd>
 <dt>{{domxref("FileSystemWritableFileStream")}}</dt>
 <dd>is a {{domxref('WritableStream')}} object with additional convenience methods, which operates on a single file on disk.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Accessing_files.">Accessing files.</h3>

<p>The below code allows the user to choose a file from the file picker and then tests to see whether the handle returned is a file or directory</p>

<pre class="brush: js notranslate">// store a reference to our file handle
let fileHandle;

async function getFile() {
  // open file picker
  [fileHandle] = await window.showOpenFilePicker();

  if (fileHandle.type === 'file') {
    // run file code
  } else if (fileHandle.type === 'directory')
    // run directory code
  }

}
</pre>

<p>The following asynchronous function presents a file picker and once a file is chosen, uses the <code>getFile()</code> method to retrieve the contents.</p>

<pre class="brush: js notranslate">const pickerOpts = {
  types: [
    {
      description: 'Images',
      accept: {
        'image/*': ['.png', '.gif', '.jpeg', '.jpg']
      }
    },
  ],
  excludeAcceptAllOption: true,
  multiple: false
};

async function getTheFile() {
  // open file picker
  [fileHandle] = await window.showOpenFilePicker(pickerOpts);

  // get file contents
  const fileData = await fileHandle.getFile();
}</pre>

<h3 id="Accessing_directories.">Accessing directories.</h3>

<p>The following example returns a directory handle with the specified name, if the directory does not exist it is created.</p>

<pre class="brush: js notranslate">const dirName = 'directoryToGetName';

// assuming we have a directory handle: 'currentDirHandle'
const subDir = currentDirHandle.getDirectoryHandle(dirName, {create: true});</pre>

<p>The following asynchronous function uses <code>resolve()</code> to find the path to a chosen file, relative to a specified directory handle.</p>

<pre class="brush: js notranslate">async function returnPathDirectories(directoryHandle) {

  // Get a file handle by showing a file picker:
  const handle = await self.showOpenFilePicker();
  if (!handle) {
    // User cancelled, or otherwise failed to open a file.
    return;
  }

  // Check if handle exists inside directory our directory handle
  const relativePaths = await directoryHandle.resolve(handle);

  if (relativePath === null) {
    // Not inside directory handle
  } else {
    // relativePath is an array of names, giving the relative path

    for (const name of relativePaths) {
      // log each entry
      console.log(name);
    }
  }
}
</pre>

<h3 id="Writing_to_files.">Writing to files.</h3>

<p>This asynchronous function opens the save file picker, which returns a {{domxref('FileSystemFileHandle')}} once a file is selected. From which a writable stream is then created using the {{domxref('FileSystemFileHandle.createWritable()')}} method.</p>

<p>A user defined {{domxref('Blob')}} is then written to the stream which is subsequently closed.</p>

<pre class="brush: js notranslate">async function saveFile() {

  // create a new handle
  const newHandle = await window.showSaveFilePicker();

  // create a FileSystemWritableFileStream to write to
  const writableStream = await newHandle.createWritable();

  // write our file
  await writableStream.write(imgBlob);

  // close the file and write the contents to disk.
  await writableStream.close();
}
</pre>

<p>The following show different examples of options that can be passed into the <code>write()</code> method.</p>

<pre class="brush: js notranslate">// just pass in the data (no options)
writableStream.write(data)

// writes the data to the stream from the determined position
writableStream.write({ type: "write", position: position, data: data })

// updates the current file cursor offset to the position specified
writableStream.write({ type: "seek", position: position })

// resizes the file to be size bytes long
writableStream.write({ type: "truncate", size: size })
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access API')}}</td>
   <td>{{Spec2('File System Access API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemAccess")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
